﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using TMPro;
using UnityEngine.UI;

public class MainMenuController : MonoBehaviour{

    [SerializeField] Button playButton;
    [SerializeField] Button creditsButton;
    [SerializeField] Button settingsButton;
    [SerializeField] Button settingsAcceptButton;
    [SerializeField] Button exitButton;

    [Space]
    [SerializeField] GameObject title;
    [SerializeField] GameObject menuButtons;
    [SerializeField] GameObject settingsPanel;

    // Start is called before the first frame update
    void Start(){
        AudioManager.instance.StopAll();
        AudioManager.instance.Play("forest");

        if (playButton != null)
            playButton.onClick.AddListener(Play);

        if (creditsButton != null)
            creditsButton.onClick.AddListener(Credits);

        if (settingsButton != null)
            settingsButton.onClick.AddListener(Settings);

        if (settingsAcceptButton != null)
            settingsAcceptButton.onClick.AddListener(SettingsAccept);

        if (exitButton != null)
            exitButton.onClick.AddListener(Exit);
    }

    void Play(){
        Loader.Load(1);
    }

    void Credits(){
        //SceneManager.LoadScene("Credits");
    }

    void Settings(){
        title.SetActive(false);
        menuButtons.SetActive(false);
        settingsPanel.SetActive(true);
    }
    void SettingsAccept(){
        title.SetActive(true);
        menuButtons.SetActive(true);
        settingsPanel.SetActive(false);
    }

    void Exit(){
        Application.Quit();
    }
}
